﻿
function nowak_liao_asexual_bmw(bmin, bstep, bmax, mmin, mstep, mmax, wmin, wstep, wmax, T, Td)
   
    bset = [bmin:bstep:bmax]; 
    mset = [mmin:mstep:mmax]; 
    wset = [wmin:wstep:wmax]; 
    [bi, bn] = size(bset);
    [mi, mn] = size(mset);
	[wi, wn] = size(wset);
    
    bmw = zeros(bn, mn, wn);
    
    for i = 1:bn
        b = bset(i);
        for j = 1:mn
            m = mset(j);
            for k = 1:wn
                w = wset(k);
                bmw(i, j, k) = nowak_liao_asexual(b, m, w, T, Td);
            end
        end
    end
   
     dlmwrite('mwbd.data', bmw, 'delimiter', '\t');
end


function bmw = nowak_liao_asexual(b, m, w, T, Td)
    
    [b0, d0, d, alpha, eta, n] = nowak_liao_asexual_init_constant();
    B = nowak_liao_asexual_init_B(m, b0, b, w);
    D = nowak_liao_asexual_init_D(m, d0, d, w); 
    [em, Xe, Xs]= nowak_liao_asexual_eusociality(b0, d0, B, D, alpha, eta, n, w, T, Td);

    if (Xe >= Xs)
        bmw = 1;
    else
        bmw = 0;
    end
end


function [b0, d0, d, alpha, eta, n] = nowak_liao_asexual_init_constant()   
    b0 = 0.5;
    d0 = 0.1;
    d  = 0.01;     
    alpha = 0.1;   
    eta   = 0.01;   
  	n = 100;   
end


function B = nowak_liao_asexual_init_B(m, b0, b, mm)
	B = ones(mm, 1) * b;
    for i = 1:m-1
        B(i) = b0 + (b-b0) * (i-1) / (m-1);
    end
end
  
  
function D = nowak_liao_asexual_init_D(m, d0, d, mm)
	D = ones(mm, 1) * d;
    %D = ones(mm, 1) * d0;
    for i = 1:m-1
        D(i) = d0 + (d-d0) * (i-1) / (m-1);
       % D(i) = d0;
    end
end


function [eqpb, Xetd, Xstd] = nowak_liao_asexual_eusociality(b0, d0, B, D, alpha, eta, n, w, T, Td)
	eqpb = 0;	
	zerodef = 0.0001;    

    Etd = zeros(1, w);
    Etd(1, 1) = n;
    Std = n;     
    
    for t = 1:T-1  
        for tdi = 1:Td
        	Xetd = population_ES(Etd, w);
            Xstd = Std;
            if Xstd < zerodef
	        	eqpb = 1;
	            return;
	        elseif Xetd < zerodef
                eqpb = 0;
	        	return;
	        end 
	        
	        phi = 1 / (1 + eta * (Xetd + Xstd));
	        
            Me = matrix_E(B, D, alpha, phi, w);               
            Etd(1, :) = (Etd(1, :)' + Me * Etd(1, :)' / Td)';
            
            Std = Std + (phi * b0 - d0) * Std / Td;
        end
    end 
end


function X = population_ES( ESmm, w)
    X = 0;
    for i = 1:w
        X = X + i * ESmm(i);
    end
end


function Me = matrix_E(B0, D, alpha, phi, w)
    B = B0 * phi;
    Me = zeros(w, w);        
    for i = 2:w-1
        Me(i, i-1) = B(i-1) ;
        Me(i, i) = -B(i) - D(i) - (i-1) * alpha; 
        Me(i, i+1) = i * alpha;
    end
    Me(1,1) = -B(1) - D(1);
    Me(1,2) = alpha;
    Me(1,w) = B(w);
    Me(w,w-1) = B(w-1);
    Me(w,w) = -D(w) - (w-1) * alpha;
end
